import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class Main {
  public static void main(String[] a) throws Exception {
    JPAUtil util = new JPAUtil();

    EntityManagerFactory emf = Persistence.createEntityManagerFactory("ProfessorService");
    EntityManager em = emf.createEntityManager();
    ProfessorService service = new ProfessorService(em);

    em.getTransaction().begin();

    service.createProfessor("country", 1, "name", 100);
    service.createProfessor("mgrcountry", 2, "mgrName", 100);
    service.createProject("proj");
    service.addProfessorProject("empCountry2", 1, 1);
    service.setProfessorManager("Country", 1, "mgrCountry", 1);



    System.out.println("Professors:");
    for (Professor emp : service.findAllProfessors()) {
      System.out.println(emp + " " + emp.getProjects().size());
      System.out.println(emp + " " + emp.getManager());
    }

    System.out.println("Projects:");
    for (Project p : service.findAllProjects()) {
      System.out.print(p + " " + p.getProfessors().size());
    }

    util.checkData("select * from Professor");

    em.getTransaction().commit();
    em.close();
    emf.close();
  }
}