import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String country, int id, String name, long salary) {
    Professor emp = new Professor();
    emp.setCountry(country);
    emp.setId(id);
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }
  public void createProject(String projName) {
    Project proj = new Project();
    proj.setName(projName);
    em.persist(proj);
  }
  public void setProfessorManager(String country, int id, String mgrCountry, int mgrId) {
    Professor emp = findProfessor(country, id);
    Professor mgr = findProfessor(mgrCountry, mgrId);
    emp.setManager(mgr);
    mgr.getDirects().add(emp);
  }

  public void addProfessorProject(String country, int id, int projId) {
    Professor emp = findProfessor(country, id);
    Project proj = em.find(Project.class, projId);
    emp.getProjects().add(proj);
    proj.getProfessors().add(emp);
  }

  public Professor findProfessor(String country, int id) {
    return em.find(Professor.class, new ProfessorId(country, id));
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

  public Collection<Project> findAllProjects() {
    Query query = em.createQuery("SELECT p FROM Project p");
    return (Collection<Project>) query.getResultList();
  }
}